#include "testlib.h"

using namespace std;

int n;

void check(vector<vector<int>> r, InStream &in) {
    int k = in.readInt(0, 2 * n, "k");
    for (int i = 0; i < k; i++) {
        int a = in.readInt(1, n + 1, format("from_%d", i + 1)) - 1;
        int b = in.readInt(1, n + 1, format("to_%d", i + 1)) - 1;
        in.ensuref(a != b, "rockets on step %d are the same rocket", i + 1);
        in.ensuref(r[a].size() > 0, "source rocket on step %d is empty", i + 1);
        in.ensuref(r[b].size() < 2, "target rocket on step %d in full", i + 1);
        r[b].push_back(r[a].back());
        r[a].pop_back();
    }

    for (int i = 0; i < n + 1; i++) {
        if (r[i].size() > 0) {
            in.ensuref(r[i].size() == 2, "rocket %d has only one shot in the end", i + 1);
            in.ensuref(r[i][0] == r[i][1], "rocket %d has different shots in the end", i + 1);
        }
    }
}

int main(int argc, char *argv[]) {

    registerTestlibCmd(argc, argv);

    n = inf.readInt();
    vector<vector<int>> rockets(n + 1);
    for (int i = 0; i < n; i++) {
        rockets[i] = inf.readInts(2);
    }

    check(rockets, ans);
    check(rockets, ouf);

    quitf(_ok, "all checks passed");

}