#ifdef LOCAL
#include "../../testlib.h"
#else
#include "testlib.h"
#endif

using namespace std;

int MAX_N = 100'000, MAX_M = 100'000;
int MAX_VAL = (1 << 15);

template<class T>
T opt_or_default(const string& s, T d_val) {
    return has_opt(s) ? opt<T>(s) : d_val;
}

int rnd_x(int change) {
    int x = MAX_VAL - 1;
    for (int i = 0; i < change; i++) {
        x ^= 1 << rnd.next(15);
    }
    return x;
}

int main(int argc, char *argv[]) {
    registerGen(argc, argv, 1);
    int n = opt_or_default("n", MAX_N);
    int m = opt_or_default("m", MAX_M);
    cout << n << " " << m << "\n";
    for (int i = 0; i < n; i++) {
        cout << rnd.next(MAX_VAL);
        if (i + 1 < n) {
            cout << " ";
        }
    }
    cout << "\n";
    int w_len = opt_or_default("w_len", 0);
    int max_zero = opt_or_default("mz", 0);
    for (int i = 0; i < m; i++) {
        int val = rnd.next(3);
        int len = rnd.wnext(n, w_len);
        int l = rnd.next(1, n - len);
        if (val < 1) {
            cout << 1 << " " << l << " " << l + len << "\n";
        } else if (val < 2) {
            int x = rnd_x(max_zero);
            cout << 2 << " " << l << " " << l + len << " " << x << "\n";
        } else {
            int x = rnd_x(max_zero);
            const string cmd = rnd.next("^|&|\\|");
            cout << 3 << " " << l << " " << l + len << " " << x << " " << cmd << "\n";
        }
    }
}